SystemOrganization addCategory: #'Roassal2-Builder-MondrianOLD'!

RTBoundedShapeBuilder subclass: #RTMondrianShapeBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2-Builder-MondrianOLD'!

!RTMondrianShapeBuilder methodsFor: 'shapes' stamp: 'AlexandreBergel 12/6/2014 20:12'!
circle
	super circle
		withBorder! !

!RTMondrianShapeBuilder methodsFor: 'shapes' stamp: 'AlexandreBergel 3/22/2014 10:50'!
defaultColor
	^ Color white! !

!RTMondrianShapeBuilder methodsFor: 'shapes' stamp: 'AlexandreBergel 3/17/2014 14:51'!
rectangle
	^ super rectangle withBorder! !

RTTest subclass: #RTMondrianViewBuilderTest
	instanceVariableNames: 'builder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2-Builder-MondrianOLD'!

!RTMondrianViewBuilderTest methodsFor: 'basic' stamp: 'AlexandreBergel 4/11/2017 17:43'!
setUp
	super setUp.
	builder := RTMondrianViewBuilder new! !

!RTMondrianViewBuilderTest methodsFor: 'basic' stamp: 'AlexandreBergel 1/2/2014 09:29'!
testBasic
	
	builder nodes: #(1 2 3 4 5).
	builder edges: #(1 2 3 4 5) from: #yourself to: [ :v | v + 1 ].
	builder treeLayout.
	self assert: builder view numberOfElements = 5.
	self assert: builder view numberOfEdges = 4.! !

!RTMondrianViewBuilderTest methodsFor: 'basic' stamp: 'AlexandreBergel 1/13/2015 14:28'!
testCheckCanvas

	| b c |
	b := RTMondrianViewBuilder new.
	b shape label text: #asString.
	b nodes: (1 to: 100).
	b shape orthoHorizontalLine color: Color veryLightGray.
	b edgesFrom: [:x | x // 10].
	b horizontalTreeLayout layered.
	c := b view canvas.
	self assert: (c shapes noneSatisfy: [ :s | s class == TRCompositeShape ])! !

!RTMondrianViewBuilderTest methodsFor: 'layout' stamp: 'AlexandreBergel 1/18/2014 10:45'!
testDefaultLayout

	self assert: builder layout class == RTHorizontalLineLayout! !

!RTMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 1/19/2014 18:23'!
testEdgesFrom

	| view |
	builder nodes: (Array with: 1 with: 2).
	builder edgesFrom: [ :v | v - 1 ].
	view := builder view.
	
	self assert: view numberOfElements equals: 2.
	self assert: view numberOfEdges equals: 1.
	
	self assert: view edges anyOne shape class == RTLine! !

!RTMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 2/24/2014 19:14'!
testEdgesFromAndEdgesFromTo

	| b1 b2 m1 m2 |
	b1 := RTMondrianViewBuilder new.
	b1 nodes: (1 to: 10).
	b1 edges: (1 to: 10) from: [ :v | v // 2 ] to: #yourself.
	b1 treeLayout.
	b1 applyLayout.
	
	b2 := RTMondrianViewBuilder new.
	b2 nodes: (1 to: 10).
	b2 edgesFrom: [ :v | v // 2 ].
	b2 treeLayout.
	b2 applyLayout.
	
	"The edges are pointing to the right thing"
	self assert: b1 view edges size = 9.
	self assert: b2 view edges size = 9.	
	m1 := b1 view edges collect: [ :e | Array with: e from model with: e to model ].
	m2 := b2 view edges collect: [ :e | Array with: e from model with: e to model ].
	self assert: m1 = m2.
	
	"The position of the elements"
	m1 := b1 view elements collect: #position.
	m2 := b2 view elements collect: #position.
	self assert: m1 = m2.! !

!RTMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 1/19/2014 18:25'!
testEdgesFromToAll

	| view edge nodes |
	builder nodes: (Array with: 1 with: 2).
	builder edges: (Array with: 1) from: #yourself toAll: (Array with: 2).
	view := builder view.
	
	self assert: view numberOfElements equals: 2.
	self assert: view numberOfEdges equals: 1.
	
	edge := view edges anyOne.
	nodes := view elements.
	self assert: edge from == nodes first.
	self assert: edge to == nodes second.
	self assert: edge shape class == RTLine! !

!RTMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 9/24/2014 18:23'!
testEdgesToAll

	builder shape rectangle.
	builder nodes: #(1 2 3).
	self assert: builder view edges size equals: 0.
	
	builder shape line.
	builder edgesToAll: #(2).
	self assert: builder view edges size equals: 2.
	(builder view edges collect: #to) do: [ :eachTarget |
		self assert: eachTarget model equals: 2 ].
	(builder view edges collect: #from) do: [ :eachSource |
		self deny: eachSource model = 2 ].! !

!RTMondrianViewBuilderTest methodsFor: 'layout' stamp: 'AlexandreBergel 2/10/2014 17:00'!
testForceBasedLayout
	| b |
	b := RTMondrianViewBuilder new.
	b shape rectangle.
	b nodes: (1 to: 5).
	b forceBasedLayout.
	b applyLayout! !

!RTMondrianViewBuilderTest methodsFor: 'layout' stamp: 'AlexandreBergel 1/19/2014 17:46'!
testLayoutAndTreeLayout
	| view |
	builder nodes: (Array with: 'hello') forEach: [ :e |
		
		builder nodes: (1 to: 5).
		builder shape line color: Color black.
		builder edges: (Array with: 1) from: #yourself toAll: (1 to: 5).
		builder treeLayout. 
		].
	builder gridLayout.
	builder applyLayout.
	
	view := builder view.
	self assert: (view elementFromModel: 1) position ~= (view elementFromModel: 2) position! !

!RTMondrianViewBuilderTest methodsFor: 'basic' stamp: 'AlexandreBergel 1/2/2014 22:27'!
testNesting

	builder nodes: #(1 10) forEach: [ :v | builder nodes: (Array with: v + 1 with: v + 2) ].
	self assert: builder view numberOfElements = 6.
	self assert: builder topLevelNodes size = 2.
	self assert: (builder topLevelNodes collect: #model) asArray = #(1 10).! !

!RTMondrianViewBuilderTest methodsFor: 'basic' stamp: 'AlexandreBergel 1/2/2014 22:27'!
testNestingSimple

	builder nodes: #(1) forEach: [ :v | builder nodes: #(2) ].
	self assert: builder view numberOfElements = 2.
	self assert: builder topLevelNodes size = 1! !

!RTMondrianViewBuilderTest methodsFor: 'basic' stamp: 'AlexandreBergel 1/3/2014 09:03'!
testNestingSmallTree

	builder nodes: #(100) forEach: [ :v | 
		builder nodes: #(1 2 3 4). 
		builder edges: #(1 2 3 4) from: [ :vv | vv // 2 ] to: #yourself.
		builder treeLayout ].
	
	self assert: builder view numberOfElements = 5.
	self assert: builder view numberOfEdges = 3.
	self assert: builder topLevelNodes size = 1.
	self assert: (builder view elementFromModel: 100) position = (0 @ 0).
	 ! !

!RTMondrianViewBuilderTest methodsFor: 'nesting' stamp: 'JurajKubelka 4/8/2014 10:25'!
testNestingWithEmptyContent

	| elements |
	elements := builder nodes: #(1 2 ) forEach: [ :each | ].
	self assert: elements size = 2.
	self assert: elements second extent = (10 @ 10)! !

!RTMondrianViewBuilderTest methodsFor: 'basic' stamp: 'AlexandreBergel 1/10/2014 14:31'!
testNoShape

	| nodes  node |
	nodes := builder nodes: #(10).
	self assert: nodes notNil.
	self assert: nodes size equals: 1.
	
	node := nodes first.
	self assert: node shape class == RTBox.
	self assert: node trachelShape class == TRBoxShape! !

!RTMondrianViewBuilderTest methodsFor: 'basic' stamp: 'AlexandreBergel 9/5/2014 16:58'!
testNodeAreDraggablePerDefault

	| el |
	el := builder node: 'hello'.
	self assert: el position = (0 @ 0).
	el announce: (TRMouseDragging step: 10 @ 5).
	self assert: (el position closeTo: (10 @ 5))! !

!RTMondrianViewBuilderTest methodsFor: 'basic' stamp: 'AlexandreBergel 2/24/2014 23:43'!
testOrderingTopLevelNodesAndEdges

	| v c shapes |
	builder nodes: (1 to: 2).
	builder edgesFromAssociations: (Array with: 1 -> 2).
	v := builder view.
	self assert: v numberOfElements = 2.
	self assert: v numberOfEdges = 1.
	
	c := v canvas.
	self assert: c numberOfShapes = 3.

	shapes := c shapes.
	self assert: shapes first class == TRLineShape.! !

!RTMondrianViewBuilderTest methodsFor: 'layout' stamp: 'AlexandreBergel 2/10/2014 17:00'!
testRadialTreeLayout
	| b |
	b := RTMondrianViewBuilder new.
	b shape rectangle.
	b nodes: (1 to: 5).
	b radialTreeLayout.
	b applyLayout! !

!RTMondrianViewBuilderTest methodsFor: 'basic' stamp: 'AlexandreBergel 1/2/2014 22:47'!
testTopLevel
	builder nodes: (1 to: 5).
	builder nodes: (1 to: 5).
	self assert: builder topLevelNodes size = 10! !

!RTMondrianViewBuilderTest methodsFor: 'basic' stamp: 'AlexandreBergel 1/3/2014 07:54'!
testTopLevel2
	builder nodes: (1 to: 5).
	builder nodes: (1 to: 5) forEach: [ :v | builder nodes: (Array with: v) ].
	builder nodes: (1 to: 5).
	
	self assert: builder topLevelNodes size = 15! !

!RTMondrianViewBuilderTest methodsFor: 'basic' stamp: 'AlexandreBergel 1/2/2014 22:46'!
testTopLevelDefault

	self assert: builder topLevelNodes isEmpty! !

!RTMondrianViewBuilderTest methodsFor: 'basic' stamp: 'AlexandreBergel 1/19/2014 10:35'!
testTopLevelObjects

	builder nodes: (1 to: 5).
	self assert: builder topLevelObjects asArray = (1 to: 5) asArray! !

!RTMondrianViewBuilderTest methodsFor: 'layout' stamp: 'AlexandreBergel 1/19/2014 18:39'!
testTreeLayout

	| b |
	b := RTMondrianViewBuilder new.
	b nodes: (1 to: 5).
	b shape line color: Color black.
	b edges: (Array with: 1) from: #yourself toAll: (1 to: 5).
	b treeLayout. 
	b applyLayout.
	"There are 5 different position, one for each element"
	self assert: (b view elements collect: #position) asSet size = 5! !

!RTMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 9/24/2014 18:24'!
testTwiceDefiningEdges

	builder nodes: (1 to: 20).
	builder shape line 
		colorElement: [ :edge | (edge from model = 2) 
								ifTrue: [ Color red. ] 
								ifFalse: [ Color lightGray ] ].
		
	builder edgeFromAssociation: 2 ->  18.
	builder edgesToAll: [ :v | Array with: v + 3 with: v + 5 with: v *2 ]! !

!RTMondrianViewBuilderTest methodsFor: 'layout' stamp: 'AlexandreBergel 10/14/2014 15:09'!
testVerticalLineLayout
	| b |
	b := RTMondrianViewBuilder new.
	b shape rectangle.
	b nodes: (1 to: 5).
	b verticalLineLayout.
	b applyLayout.
	self assert: (b view elements collect: #position) asArray equals: 
((Array new: 5) at: 1 put: ((2.5@2.5)); at: 2 put: ((2.5@17.5)); at: 3 put: ((2.5@32.5)); at: 4 put: ((2.5@47.5)); at: 5 put: ((2.5@62.5)); yourself).! !

!RTMondrianViewBuilderTest methodsFor: 'layout' stamp: 'AlexandreBergel 10/14/2014 15:12'!
testhorizontalDominanceTreeLayout
	| b |
	b := RTMondrianViewBuilder new.
	b shape rectangle.
	b nodes: (1 to: 5).
	b horizontalDominanceTreeLayout.
	b applyLayout.
	self assert: (b view elements collect: #position) asArray equals: 
 ((Array new: 5) at: 1 put: ((7.5@7.5)); at: 2 put: ((7.5@15.5)); at: 3 put: ((7.5@23.5)); at: 4 put: ((7.5@31.5)); at: 5 put: ((7.5@39.5)); yourself)! !
